﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.5/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var TcHmiProject1;
        (function (TcHmiProject1) {
            function SettingsPopup(pressureSensorValuePopFn, machineAlarmPopFn, rotationPerSecondsPopFn, machineNamePopFn, startMachinePopFn, machineImagePopFn, settingsNamePopFn, popUpPathPopFn, whereToInsertPopFn) {
                console.log(`pressureSensorValuePopFn = ${pressureSensorValuePopFn}`);
                console.log(`machineAlarmPopFn = ${machineAlarmPopFn}`);
                console.log(`rotationPerSecondsPopFn = ${rotationPerSecondsPopFn}`);
                console.log(`machineNamePopFn = ${machineNamePopFn}`);
                console.log(`startMachinePopFn = ${startMachinePopFn}`);
                console.log(`machineImagePopFn = ${machineImagePopFn}`);
                console.log(`settingsNamePopFn = ${settingsNamePopFn}`);
                console.log(`popUpPathPopFn = ${popUpPathPopFn}`);
                console.log(`whereToInsertPopFn = ${whereToInsertPopFn}`);

                /*
                 * //User control variable
                 1.pressureSensorValuePopup
                 2.machineAlarmPopup
                 3.rotationPerSecondsPopup
                 4.machineNamePopup
                 5.startMachinePopup
                 6.machineImagePathPopup
                 7.plcPathPopup
                 8.settingNamePopup
                 * */
            /*
             * Popup Function variable
             1.pressureSensorValuePopFn
             2.machineAlarmPopFn
             3.rotationPerSecondsPopFn
             4.machineNamePopFn
             5.startMachinePopFn
             6.machineImagePopFn
             7.settingsNamePopFn
             8.popUpPathPopFn
             * */
                var popupParametersControl = [];
                var PopupUuid = String("Popup_" + TcHmiEx.Utilities.generateUuidv4());
                var popup;
                var popupType = popUpPathPopFn.split(".");

                popupType = popupType[popupType.length - 1].toLowerCase();
                popupParametersControl['data-tchmi-left'] = TcHmiEx.Utilities.ClickCoordinates.x;
                popupParametersControl['data-tchmi-top'] = TcHmiEx.Utilities.ClickCoordinates.y;
                popupParametersControl['data-tchmi-height'] = 600;
                popupParametersControl['data-tchmi-width'] = 550;
                popupParametersControl['data-tchmi-zindex'] = "1000";

                var myControl = TcHmi.Controls.get('BaseUserControl_Settings');
                if (myControl) {
                    var symbolRealParameter = TcHmi.Binding.resolveEx('pressureSensorValueBase', myControl); // note that pressuresensorvaluebase != pressureSensorValueBase
                    if (symbolRealParameter) {
                        popupParametersControl['data-tchmi-pressuresensorvaluepopup'] = symbolRealParameter.toString();  //1
                    }

                    var symbolMachineAlarm = TcHmi.Binding.resolveEx('machineAlarmBase', myControl);
                    if (symbolMachineAlarm) {
                        popupParametersControl['data-tchmi-machinealarmpopup'] = symbolMachineAlarm.toString();  //2
                    }

                    var symbolrotationPerSeconds = TcHmi.Binding.resolveEx('rotationPerSecondsBase', myControl);
                    if (symbolrotationPerSeconds) {
                        popupParametersControl['data-tchmi-rotationpersecondspopup'] = symbolrotationPerSeconds.toString();  //3
                    }

                    var symbolmachineName = TcHmi.Binding.resolveEx('machineNameBase', myControl);
                    if (symbolmachineName) {
                        popupParametersControl['data-tchmi-machinenamepopup'] = symbolmachineName.toString();  //4
                    }

                    var symbolstartMachine = TcHmi.Binding.resolveEx('startMachineBase', myControl);
                    if (symbolstartMachine) {
                        popupParametersControl['data-tchmi-startmachinepopup'] = symbolstartMachine.toString();  //5
                    }
                }

                // machineimagepathpopup work but machineimagepathpopfn does not work (it does not show the image)
                popupParametersControl['data-tchmi-machineimagepathpopup'] = machineImagePopFn;  //6

                //Without the following does not show the content, data-tchmi-settingnamepopup is parameter for popup user control
                popupParametersControl['data-tchmi-settingnamepopup'] = settingsNamePopFn; //7

                //Without the following does not show the content
                popupParametersControl['data-tchmi-plcpathpopup'] = popUpPathPopFn; //8

                if (whereToInsertPopFn == undefined) { whereToInsertPopFn = "Desktop" }
                if (popupType == "usercontrol") {
                    popupParametersControl['data-tchmi-target-user-control'] = popUpPathPopFn;
                    popup = TcHmi.ControlFactory.createEx(
                        'tchmi-user-control-host',
                        PopupUuid,
                        popupParametersControl
                    );
                }

                var desktop = TcHmi.Controls.get(whereToInsertPopFn.__id);
                if (desktop && popup) {
                    desktop.addChild(popup);
                    TcHmiEx.Utilities.dragElement(document.getElementById(PopupUuid));
                }
            }
            TcHmiProject1.SettingsPopup = SettingsPopup;
        })(TcHmiProject1 = Functions.TcHmiProject1 || (Functions.TcHmiProject1 = {}));
        Functions.registerFunctionEx('SettingsPopup', 'TcHmi.Functions.TcHmiProject1', TcHmiProject1.SettingsPopup);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);